package guanlixitong

import (
	"math/rand"
	"strconv"
	"strings"
	"time"

	wemeet "github.com/TencentCloud/wemeet-openapi-sdk-go/wemeet_openapi"
	wemeetcore "github.com/TencentCloud/wemeet-openapi-sdk-go/wemeet_openapi/core"
	meetings "github.com/TencentCloud/wemeet-openapi-sdk-go/wemeet_openapi/service/meetings"
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"
)

type conference struct {
	Table
	fields string `data:"title,content,user_uid"`
	create string `name:"create title* content*" role:"leader"`
	remove string `name:"remove" role:"leader"`
	join   string `name:"join" help:"入会" style:"notice" role:"void"`
}

func (s conference) List(m *ice.Message, arg ...string) {
	s.V1MeetingsGet(m, "admin1731860473", "1")
	m.PushAction(s.Join)
	m.Display("")
}
func (s conference) Join(m *ice.Message, arg ...string) { m.ProcessOpen(m.Option("join_url")) }

func init() { ice.TeamCtxCmd(conference{}) }

func (s conference) V1MeetingsGet(m *ice.Message, arg ...string) {
	client, authenticator := s.newClient(m)
	response, err := client.MeetingsApi.V1MeetingsGet(m, &meetings.ApiV1MeetingsGetRequest{
		Userid: &arg[0], Instanceid: &arg[1],
	}, wemeetcore.WithJWTAuth(authenticator))
	s.resTable(m, response.Data, err, "meeting_info_list",
		"subject", "meeting_code", "start_time", "end_time", "join_url",
	)
}
func (s conference) resTable(m *ice.Message, data ice.Any, err error, key string, arg ...string) {
	if err != nil {
		m.Echo(kit.Formats(err))
	} else {
		data := kit.UnMarshal(kit.Formats(data))
		kit.For(kit.Value(data, key), func(value ice.Map) {
			kit.For(arg, func(key string) {
				if strings.HasSuffix(key, "_time") {
					t := time.Unix(kit.Int64(value[key]), 0)
					m.Push(key, strings.TrimSuffix(t.Format(ice.MOD_TIME), ":00.000"))
				} else {
					m.Push(key, value[key])
				}
			})
		})
	}
}
func (s conference) newClient(m *ice.Message, arg ...string) (*wemeet.Client, *wemeetcore.JWTAuthenticator) {
	client := wemeet.NewClient(wemeet.WithAppId("234460469"), wemeet.WithSdkId("27510111425"),
		wemeet.WithSecret("i4MYQuEzVtd0Jb5qbecDMXgSLD2AhQh0", "mYkEPBtGPYjcu0a5gvlK2HNGU0ZRDaG5AAssB29Dvp2A3FB6"))
	rn := rand.New(rand.NewSource(time.Now().UnixNano()))
	nonce := uint64(100000 + rn.Intn(900000))
	curTs := strconv.Itoa(int(time.Now().Unix()))
	authenticator := &wemeetcore.JWTAuthenticator{Nonce: nonce, Timestamp: curTs}
	return client, authenticator
}
